%define anolis_release 1
Name:           libjpeg-turbo
Version:        3.0.2
Release:        %{anolis_release}%{?dist}
Summary:        A MMX/SSE2/SIMD accelerated library for manipulating JPEG image files
License:        Zlib AND BSD-3-Clause AND MIT AND IJG
URL:            https://github.com/%{name}/%{name}

Source0:        %{url}/releases/download/%{version}/%{name}-%{version}.tar.gz

# https://gitlab.com/redhat/centos-stream/rpms/libjpeg-turbo/-/commit/be16e256620491a81250cf5414f6c4937644c135 
Patch0:         libjpeg-turbo-cmake.patch
# https://github.com/libjpeg-turbo/libjpeg-turbo/commit/db1afe88c361ceea22c6ac8abdb9b0ff41a39aa2#diff-420e05206ac7159bd7fed1f1c9c4f5f29db569af21aefca4f293229af996b1fb
Patch1:		libjpeg-turbo-CET.patch
Patch2:		0001-skip-djpeg-shared-3x2-float-prog-cmp-for-loongarch64.patch

BuildRequires:  gcc
BuildRequires:  cmake
BuildRequires:  libtool
BuildRequires:  nasm

Obsoletes:      libjpeg < 6b-47
Provides:       libjpeg = 6b-47%{?dist}

%description
The libjpeg-turbo package contains a library of functions for manipulating JPEG
images.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%package devel
Summary:        Headers for the libjpeg-turbo library
Obsoletes:      libjpeg-devel < 6b-47
Provides:       libjpeg-devel = 6b-47%{?dist}
Requires:       libjpeg-turbo = %{version}-%{release}
Obsoletes:      libjpeg-turbo-static < 1.3.1
Provides:       libjpeg-turbo-static = 1.3.1%{?dist}

%description devel
This package contains header files necessary for developing programs which will
manipulate JPEG files using the libjpeg-turbo library.

%package utils
Summary:        Utilities for manipulating JPEG images
Requires:       libjpeg-turbo = %{version}-%{release}

%description utils
The libjpeg-turbo-utils package contains simple client programs for accessing
the libjpeg functions. It contains cjpeg, djpeg, jpegtran, rdjpgcom and
wrjpgcom. Cjpeg compresses an image file into JPEG format. Djpeg decompresses a
JPEG file into a regular image file. Jpegtran can perform various useful
transformations on JPEG files. Rdjpgcom displays any text comments included in a
JPEG file. Wrjpgcom inserts text comments into a JPEG file.

%package -n turbojpeg
Summary:        TurboJPEG library

%description -n turbojpeg
The turbojpeg package contains the TurboJPEG shared library.

%package -n turbojpeg-devel
Summary:        Headers for the TurboJPEG library
Requires:       turbojpeg = %{version}-%{release}

%description -n turbojpeg-devel
This package contains header files necessary for developing programs which will
manipulate JPEG files using the TurboJPEG library.

%prep
%autosetup -p1

%build
export LDFLAGS="$RPM_LD_FLAGS -Wl,-z,ibt -Wl,-z,shstk"

%{cmake} -DCMAKE_SKIP_RPATH:BOOL=YES \
         -DCMAKE_SKIP_INSTALL_RPATH:BOOL=YES \
         -DENABLE_STATIC:BOOL=NO

%cmake_build

%install
%cmake_install

# Fix perms
chmod -x README.md

%generate_compatibility_deps

%check
export LD_LIBRARY_PATH=%{buildroot}%{_libdir}
%ctest

%files
%dir %{abidir}
%license LICENSE.md
%{_libdir}/libjpeg.so.62*
%{abidir}/libjpeg*.dump

%files doc
%doc README.md README.ijg ChangeLog.md

%files devel
%doc coderules.txt jconfig.txt libjpeg.txt structure.txt
%{_includedir}/jconfig*.h
%{_includedir}/jerror.h
%{_includedir}/jmorecfg.h
%{_includedir}/jpegint.h
%{_includedir}/jpeglib.h
%{_libdir}/libjpeg.so
%{_libdir}/pkgconfig/libjpeg.pc
%{_libdir}/cmake/%{name}/%{name}*.cmake

%files utils
%doc usage.txt wizard.txt
%{_bindir}/cjpeg
%{_bindir}/djpeg
%{_bindir}/jpegtran
%{_bindir}/rdjpgcom
%{_bindir}/wrjpgcom
%{_bindir}/tjbench
%{_mandir}/man1/cjpeg.1*
%{_mandir}/man1/djpeg.1*
%{_mandir}/man1/jpegtran.1*
%{_mandir}/man1/rdjpgcom.1*
%{_mandir}/man1/wrjpgcom.1*

%files -n turbojpeg
%license LICENSE.md
%doc README.md README.ijg ChangeLog.md
%{_libdir}/libturbojpeg.so.0*
%{abidir}/libturbojpeg*.dump

%files -n turbojpeg-devel
%doc tjexample.c
%{_includedir}/turbojpeg.h
%{_libdir}/libturbojpeg.so
%{_libdir}/pkgconfig/libturbojpeg.pc

%changelog
* Wed Mar 05 2025 mgb01105731 <mgb01105731@alibaba-inc.com> - 3.0.2-1
- Update to 3.0.2 from 3.0.0
- Migrated to SPDX license
- Remove patch as the new version of tarball already includes changes.
- Update patches to enable tjbench to fix some bugs.
- Add patches to add endbr32/endbr64 instructions.
  [Patches cherry-pick from c10s. Original changelog:
  - New upstream release 3.0.2]

* Tue Nov  7 2023 Wenlong Zhang<zhangwenlong@loongson.cn> - 3.0.0-2
- skip djpeg-shared-3x2-float-prog-cmp for loongarch64

* Mon Jul 31 2023 Funda Wang <fundawang@yeah.net> - 3.0.0-1
- New version 3.0.0

* Wed Feb 15 2023 Funda Wang <fundawang@yeah.net> - 2.1.5.1-1
- New version 2.1.5.1

* Mon Oct 24 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 2.1.3-2
- optimise spec file & add doc package

* Mon Sep 05 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.1.4-1
- update to 2.1.4

* Thu Apr 21 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 2.1.3-1
- Init from  upstream version 2.1.3

